/*---------------------------------------------------------------------------+
|	This file is part of MuMail, Copyright (c) 1992-1993 by
|	Muhammad M. Saggaf. All rights reserved.
|
|	See the file COPYING (1-COPYING) or the manual page mumail(1)
|	for a full statement of rights and permissions.
+---------------------------------------------------------------------------*/

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>
#include <string.h>
#include "MuWin.h"
#include "MmDecl.h"

void
ClearCutBufferAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  XStoreBytes(XtDisplay(widget), "", 1);
}

void
CloseWindowAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  if ((widget = XtWindowToWidget(event->xany.display, event->xany.window)) 
	  == NULL) return;
  CloseWindow(WidgetToScn(widget));
}

void
HighlightCurrentLineAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  HighlightCurrentLine(widget);
}

void
SetCurLetterNumberAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  SetCurLetterNumber(WidgetToScn(widget));
}

void
HighlightToEndOFLineAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  SCREEN *scn = WidgetToScn(widget);
  HighlightToEndOFLine(scn->tocW);
}

void
IncCurLetterNumberAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  SCREEN *scn = WidgetToScn(widget);
  
  if (scn->folder.curLetterN + 1 > scn->folder.numLetters - 1) return;
  ++(scn->folder.curLetterN);
}

void
DecrCurLetterNumberAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  SCREEN *scn = WidgetToScn(widget);
  
  if (scn->folder.curLetterN - 1 < 0) return;
  --(scn->folder.curLetterN);
}

void
DisplayCurLetterPartialAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  DisplayCurLetterPartial(WidgetToScn(widget));
}

void
DisplayCurLetterWholeAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  DisplayCurLetterWhole(WidgetToScn(widget));
}

void
DisplayInsertionPointPosAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  printf("pos = %d\n", XawTextGetInsertionPoint(WidgetToScn(widget)->tocW));
}

void
OpenFolderAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  OpenFolderCallback(widget, (XtPointer)WidgetToScn(widget), (XtPointer)NULL);
}

void
SaveFolderAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  CbSaveFolder(WidgetToScn(widget));
}

void
QuickExitAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  QuickExit(WidgetToScn(widget));
}

void
ExitAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  Exit(WidgetToScn(widget));
}

void
TagUntagLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  TagUntagLetterCallback(widget, (XtPointer)WidgetToScn(widget), 
						 (XtPointer)NULL);
}

void
RetagLettersAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  RetagLettersCallback(widget, (XtPointer)WidgetToScn(widget), 
					   (XtPointer)NULL);
}

void
DeleteLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  DeleteLetterCallback(widget, (XtPointer)WidgetToScn(widget), 
					   (XtPointer)NULL);
}

void
UndeleteLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  UndeleteLetterCallback(widget, (XtPointer)WidgetToScn(widget), 
						 (XtPointer)NULL);
}

void
ComposeLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  ComposeLetter(WidgetToScn(widget));
}

void
ReplyToLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  ReplyToLetter(WidgetToScn(widget));
}

void
ForwardLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  ForwardLetter(WidgetToScn(widget));
}

void
ExternalComposeLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  ExternalComposeLetter(WidgetToScn(widget));
}

void
CopyLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  CopyLetterCallback(widget, (XtPointer)WidgetToScn(widget), (XtPointer)NULL);
}

void
RefileLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  RefileLetterCallback(widget, (XtPointer)WidgetToScn(widget), 
					   (XtPointer)NULL);
}

void
WriteLetterAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  WriteLetterCallback(widget, (XtPointer)WidgetToScn(widget), 
					  (XtPointer)NULL);
}

void
LetterInfoAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  LetterInfo(WidgetToScn(widget));
}

void
QuoteRnStyleAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  QuoteRnStyleCallback(widget, (XtPointer)WidgetToScn(widget), 
					   (XtPointer)NULL);
}

void
QuoteScStyleFmtAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  QuoteScStyleProc(WidgetToScn(widget), QUOTE_SC_STYLE_IND);
}

void
QuoteScStyleUnfmtAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  QuoteScStyleProc(WidgetToScn(widget), QUOTE_SC_STYLE_UNIND);
}

void
InsertSignatureAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  InsertSignatureCallback(widget, (XtPointer)WidgetToScn(widget), 
						  (XtPointer)NULL);
}

void
CancelDraftAction(widget, event, param, numParam)
	 Widget          widget;
	 XEvent*         event;
	 String*         param;
	 Cardinal*       numParam;
{
  CancelDraftCallback(widget, (XtPointer)WidgetToScn(widget), 
					  (XtPointer)NULL);
}

