/*---------------------------------------------------------------------------+
|	This file is part of MuMail, Copyright (c) 1992-1993 by
|	Muhammad M. Saggaf. All rights reserved.
|
|	See the file COPYING (1-COPYING) or the manual page mumail(1)
|	for a full statement of rights and permissions.
+---------------------------------------------------------------------------*/

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include "MuWin.h"
#include "MuGeneric.h"
#include "MmDecl.h"

Boolean
BodyBoxEditable(scn)
	 SCREEN           *scn;
{
  XawTextEditType editType;

  XtVaGetValues(scn->bodyW, XtNeditType, &editType, NULL);
  return (Boolean)(editType == XawtextEdit);
}

void 
DisplayBufferInBodyBox(scn, buffer)
	 SCREEN           *scn;
	 String            buffer;
{
  XawTextDisableRedisplay(scn->bodyW);
  XtVaSetValues(scn->bodyW, XtNtype, XawAsciiString, XtNstring, 
				buffer, XtNdisplayCaret, False, XtNeditType, XawtextRead, 
				NULL);
  XawTextEnableRedisplay(scn->bodyW);
}

void 
DisplayFileInBodyBox(scn, fileName)
	 SCREEN           *scn;
	 String            fileName;
{
  XawTextDisableRedisplay(scn->bodyW);
  XtVaSetValues(scn->bodyW, XtNtype, XawAsciiFile, XtNstring, fileName,
				XtNdisplayCaret, False, XtNeditType, XawtextRead, NULL);
  XawTextEnableRedisplay(scn->bodyW);
}

void
EditFileInBodyBox(scn, fileName)
	 SCREEN          *scn;
	 String          fileName;
{
  String          buffer;

  if ((buffer = CopyFileToBuffer(fileName)) == NULL)
	return;
  scn->edit.fileName = fileName;

  XawTextDisableRedisplay(scn->bodyW);
  XtVaSetValues(scn->bodyW, XtNtype, XawAsciiString, XtNstring, buffer, 
				XtNeditType, XawtextEdit, XtNdisplayCaret, True, NULL);
  XawTextEnableRedisplay(scn->bodyW);

  XtFree(buffer);
}

void
ExternalEditFileOfBodyBoxCallback(widget, clientData, callData)
	 Widget             widget;
	 XtPointer          clientData;
	 XtPointer          callData;
{
  SCREEN          *scn = (SCREEN*)clientData;

  if (XawAsciiSaveAsFile(XawTextGetSource(scn->bodyW), scn->edit.fileName) 
	  == False) return;

  ExternalEditFile(scn->edit.fileName);
  EditFileInBodyBox(scn, scn->edit.fileName);
} 

