/*---------------------------------------------------------------------------+
|	This file is part of MuMail, Copyright (c) 1992-1993 by
|	Muhammad M. Saggaf. All rights reserved.
|
|	See the file COPYING (1-COPYING) or the manual page mumail(1)
|	for a full statement of rights and permissions.
+---------------------------------------------------------------------------*/

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "MuWin.h"
#include "MmDecl.h"

extern void
         DisplayLogoCallback(),
         DisplayHelpFileCallback();

extern void

         NotImplementedCallback(),
         NewWindowCallback(),
         CloseWindowCallback(),

         IncorporateNewMailCallback(),
         OpenFolderCallback(),
         ReOpenFolderCallback(),
         OpenFolderInNextScreenCallback(),
         NewFolderCallback(),
         SaveFolderCallback(),
         SaveFolderAsCallback(),
         EditFolderCallback(),
         DeleteFolderCallback(),
         CommitChangesCallback(),
         SortFolderCallback(),
         SearchFolderCallback(),
         FolderInfoCallback(),
         RedisplayTocCallback(),
         ExitCallback(),

         DisplayCurLetterPartialCallback(),
         DisplayCurLetterWholeCallback(),
         DisplayLetterPartialInNextScreenCallback(),
         TagAllLettersCallback(),
         UntagAllLettersCallback(),
         ComposeLetterCallback(),
         ReplyToLetterCallback(),
         ForwardLetterCallback(),
         QuoteScStyleFmtAndReplyCallback(),
         QuoteScStyleUnfmtAndReplyCallback(),
         QuoteRnStyleAndReplyToLetterCallback(),
         ExternalComposeLetterCallback(),
         ExternalReplyToLetterCallback(),
         LetterInfoCallback(),

         SendDraftCallback(),
         QuoteScStyleFmtCallback(),
         QuoteScStyleUnfmtCallback(),
         QuoteRnStyleCallback(),
         InsertSignatureCallback(),
         InsertLetterBodyCallback(),
         InsertLetterPartialCallback(),
         InsertLetterWholeCallback(),
         CancelDraftCallback(),

         GotoEditCallback(),
         EditSaveCallback(),
         EditCancelCallback(),
         EditCutCallback(),
         EditCutEolCallback(),
         EditPasteCallback(),
         EditSearchCallback(),
         EditInsertFileCallback(),
         EditFormatCallback(),
         EditRedrawCallback(),
         ExternalEditFileOfBodyBoxCallback();


void
CreateMainMenu(scn, topPaned)
	 SCREEN *scn;
	 Widget  topPaned;
{
  Widget     menuBox,
             button,
             menu;

  menuBox = AddBox("mainMenu", topPaned);

  /* Window Button */

  button = AddMenuButton("windowButton", menuBox);
  menu = AddSimpleMenu("windowMenu", button);
  AddMenuEntry("new", menu, NewWindowCallback, (XtPointer)scn);
  AddMenuEntry("close", menu, CloseWindowCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("exit", menu, ExitCallback, (XtPointer)scn);

  /* Folder Button */

  button = AddMenuButton("folderButton", menuBox);
  menu = AddSimpleMenu("folderMenu", button);
  AddMenuEntry("getNew", menu, IncorporateNewMailCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("open", menu, OpenFolderCallback, (XtPointer)scn); 
  AddMenuEntry("reopen", menu, ReOpenFolderCallback, (XtPointer)scn);
  AddMenuEntry("openInNextScn", menu, OpenFolderInNextScreenCallback, 
			   (XtPointer)scn);
  AddMenuEntry("new", menu, RedisplayTocCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("save", menu, SaveFolderCallback, (XtPointer)scn);
  AddMenuEntry("saveAs", menu, SaveFolderAsCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("edit", menu, EditFolderCallback, (XtPointer)scn);
  AddMenuEntry("delete", menu, DeleteFolderCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("commit", menu, CommitChangesCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("sort", menu, SortFolderCallback, (XtPointer)scn);
  AddMenuEntry("search", menu, SearchFolderCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("info", menu, FolderInfoCallback, (XtPointer)scn);
  AddMenuEntry("redisplay", menu, RedisplayTocCallback, (XtPointer)scn);

  /* Letter Button */

  button = AddMenuButton("letterButton", menuBox);
  menu = AddSimpleMenu("letterMenu", button);
  AddMenuEntry("displayPartial", menu, DisplayCurLetterPartialCallback, 
			   (XtPointer)scn);
  AddMenuEntry("displayWhole", menu, DisplayCurLetterWholeCallback, 
			   (XtPointer)scn);
  AddMenuEntry("displayPartialInNextScn", menu, 
			   DisplayLetterPartialInNextScreenCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("tag", menu, TagUntagLetterCallback, (XtPointer)scn);
  AddMenuEntry("tagAll", menu, TagAllLettersCallback, (XtPointer)scn);
  AddMenuEntry("untagAll", menu, UntagAllLettersCallback, (XtPointer)scn);
  AddMenuEntry("retag", menu, RetagLettersCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("delete", menu, DeleteLetterCallback, (XtPointer)scn);
  AddMenuEntry("undelete", menu, UndeleteLetterCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("compose", menu, ComposeLetterCallback, (XtPointer)scn);
  AddMenuEntry("reply", menu, ReplyToLetterCallback, (XtPointer)scn);
  AddMenuEntry("forward", menu, ForwardLetterCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("quoteScFmtReply", menu, QuoteScStyleFmtAndReplyCallback, 
			   (XtPointer)scn);
  AddMenuEntry("quoteScUnfmtReply", menu, QuoteScStyleUnfmtAndReplyCallback, 
			   (XtPointer)scn);
  AddMenuEntry("quoteRnReply", menu, QuoteRnStyleAndReplyToLetterCallback, 
			   (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("composeExt", menu, ExternalComposeLetterCallback, 
			   (XtPointer)scn);
/*  AddMenuEntry("replyExt", menu, ExternalReplyToLetterCallback, 
			   (XtPointer)scn);*/

  AddMenuLine("line", menu);
  AddMenuEntry("copy", menu, CopyLetterCallback, (XtPointer)scn);
  AddMenuEntry("refile", menu, RefileLetterCallback, (XtPointer)scn);
  AddMenuEntry("write", menu, WriteLetterCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("search", menu, EditSearchCallback, (XtPointer)scn);
  AddMenuEntry("info", menu, LetterInfoCallback, (XtPointer)scn);

  /* Draft Button */

  button = scn->draft.buttonW = 
	AddMenuButton("draftButton", menuBox);
  menu = AddSimpleMenu("draftMenu", button);
  AddMenuEntry("send", menu, SendDraftCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("quoteScFmt", menu, QuoteScStyleFmtCallback, (XtPointer)scn);
  AddMenuEntry("quoteScUnfmt", menu, QuoteScStyleUnfmtCallback, 
			   (XtPointer)scn);
  AddMenuEntry("quoteRn", menu, QuoteRnStyleCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("signature", menu, InsertSignatureCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("body", menu, InsertLetterBodyCallback, (XtPointer)scn);
  AddMenuEntry("partial", menu, InsertLetterPartialCallback, (XtPointer)scn);
  AddMenuEntry("whole", menu, InsertLetterWholeCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("cancel", menu, CancelDraftCallback, (XtPointer)scn);

  /* Edit Button */

  button = scn->edit.buttonW = 
	AddMenuButton("editButton", menuBox);
  menu = AddSimpleMenu("editMenu", button);
  AddMenuEntry("goto", menu, GotoEditCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  scn->edit.saveW = 
	AddMenuEntry("save", menu, EditSaveCallback, (XtPointer)scn);
  scn->edit.cancelW = 
	AddMenuEntry("cancel", menu, EditCancelCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("cut", menu, EditCutCallback, (XtPointer)scn);
  AddMenuEntry("cutEol", menu, EditCutEolCallback, (XtPointer)scn);
  AddMenuEntry("paste", menu, EditPasteCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("search", menu, EditSearchCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("insert", menu, EditInsertFileCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("format", menu, EditFormatCallback, (XtPointer)scn);
  AddMenuEntry("redraw", menu, EditRedrawCallback, (XtPointer)scn);

  AddMenuLine("line", menu);
  AddMenuEntry("editExt", menu, ExternalEditFileOfBodyBoxCallback, 
			   (XtPointer)scn);

  DraftMode(scn, False);

  /* Help Button */

  button = AddMenuButton("helpButton", menuBox);
  menu = AddSimpleMenu("helpMenu", button);
  AddMenuEntry("about", menu, DisplayLogoCallback, (XtPointer)scn);

  AddMenuLine("line", menu);

  AddMenuEntry("general", menu, DisplayHelpFileCallback, (XtPointer)scn);
  AddMenuEntry("index", menu, DisplayHelpFileCallback, (XtPointer)scn);
}

void 
NotImplementedCallback(widget, clientData, callData)
	 Widget    widget;
	 XtPointer clientData;
	 XtPointer callData;
{
  SCREEN *scn = (SCREEN*)clientData;
  Message(scn, "This feature in not yet imlemented", MSG_CLEAR_DEFAULT);
}

